#!/usr/bin/perl

$overlap = .05;  $ulpos = .24;  $ulheight = .04; # defaults

$overlap = $ARGV[1] if $#ARGV > 0;
$ulpos = $ARGV[2] if $#ARGV > 1;
$ulheight = $ARGV[3] if $#ARGV > 2;
$ovstring = sprintf("%0.4f", -$overlap); # must be fixed real
$ulht = sprintf("%0.4f", $ulheight);
if ($ARGV[0] =~ /\.pl$/) {
  $fontname = $`;
  open(PL, $ARGV[0]) or die 'Cannot open ' . $ARGV[0];
}
else {
  die 'Invalid font name';
}
$c = $f = 0;
print "(VTITLE underlined version of $fontname)\n";
while (<PL>) {
  chop;
  if (/^\((DESIGNSIZE.+)\)$/) {
    $dsize = "(FONT$1)";
  }
  $f = 1 if /^\(FONTDIMEN/;
  if (/^\(CHARACTER\s+/) {
    $c = $';
  }
  if ($c && /\(CHARWD R (.+)\)$/) {
    $wd = 2 * $overlap + $1;
  }
  if ($c && $_ eq '   )') {
    print<<"EOMAP";
   (MAP
      (PUSH)
      (MOVEDOWN R $ulpos)
      (MOVERIGHT R $ovstring)
      (SETRULE R $ulht R $wd)
      (POP)
      (SETCHAR $c)
      )
EOMAP
    $c = 0;
  }
  if ($f && $_ eq '   )') {
    $f = 0;
    $th = $ulheight - $ulpos;
    print<<"EOMAP";
   (DEFAULTRULETHICKNESS R $th)
   (BIGOPSPACING1 R $ulpos)
EOMAP
  }
  print "$_\n";
  if (/^\((CHECKSUM.*)\)$/) {
    $checksum = "(FONT$1)";
    print<<"EOMAP";
(MAPFONT D 0
   (FONTNAME $fontname)
   $checksum
   (FONTAT R 1.0)
   $dsize
   )
EOMAP
  }
}
